module NumeriRomani
  DIGITS = {
    'M̅'  => 1_000_000,
    'C̅M̅' => 900_000,
    'D̅'  => 500_000,
    'C̅D̅' => 400_000,
    'C̅'  => 100_000,
    'X̅C̅' => 90_000,
    'L̅'  => 50_000,
    'X̅L̅' => 40_000,
    'X̅'  => 10_000,
    'I̅X̅' => 9_000,
    'V̅'  => 5_000,
    'I̅V̅' => 4_000,
    'M'  => 1_000,
    'CM' => 900,
    'D'  => 500,
    'CD' => 400,
    'C'  => 100,
    'XC' => 90,
    'L'  => 50,
    'XL' => 40,
    'X'  => 10,
    'IX' => 9,
    'V'  => 5,
    'IV' => 4,
    'I'  => 1
  }.freeze

  FRACTIONS = {
    'S⁙' => 11/12r,
    'S∷' => 10/12r,
    'S∴' => 9/12r,
    'S∶' => 8/12r,
    'S⋅' => 7/12r,
    'S' => 6/12r,
    '⁙' => 5/12r,
    '∷' => 4/12r,
    '∴' => 3/12r,
    '∶' => 2/12r,
    '⋅' => 1/12r,
  }.freeze

  REGEXP = /^((M\u0305){0,3})((D\u0305)?(C\u0305){0,3}|C\u0305D\u0305|C\u0305M\u0305)((L\u0305)?(X\u0305){0,3}|X\u0305L\u0305|X\u0305C\u0305)((V\u0305)?(I\u0305){0,3}|I\u0305V\u0305|I\u0305X\u0305)(M{0,3})(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX])(#{FRACTIONS.keys.join('|')}|(S?\*{0,5}))?$/
end
